#!/tmp/.ZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZpErLZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZperl/bin/perl
use strict;
use PureMessage::Manager::Request qw($REQUEST %in);
use PureMessage::Manager::Config qw(%web_config save_web_config);
use PureMessage::Manager::Lang;
use PureMessage::Service;
use PureMessage::Manager::Response::Services::Manager;
use PureMessage::Manager::Widget;
use PureMessage::Manager::Widget::Form;
use PureMessage::Manager::Utils qw(:all);
use Socket;

my $httpd = PureMessage::Service->new('http');
my $raddr = $ENV{'REMOTE_ADDR'};

my %in;
my $WIDGET = new PureMessage::Manager::Widget;

foreach ( $REQUEST->query_names() ) {
    $in{$_} = $REQUEST->query($_);
}

my $error;

if (defined $in{"access"}) {
    save_changes();
    exit unless $error;
}

my $r = $REQUEST->get_response( 'PureMessage::Manager::Response::Services::Manager',
                                'stderr_to_stdout' =>1 );

$r->add_help(text => "Help", tab => "locserv", page => "mgr_locserv_httpd_ipaccess" );

if ( $error ) {
    $r->raise_error($error);
}
                              
$r->title(text('access_title'));
print_ui();

sub print_ui {
    # XXX this old code should be rewritten using widgets lib
    $r->print("<table width='600'><tr><td>"
         . text('access_desc')
         . "</td></tr></table><br>");
    $r->print("<form action=edit_access.cgi method=post name=edit_access>\n");
    $r->print("<table width='100%' cellspacing=1 cellpadding=1>\n");
    $r->print("<tr><td valign=top nowrap class=tableRowAlt>\n");
    $r->print( sprintf "<input type=radio name=access value=0 %s>\n",
	  $web_config{"allow"} || $web_config{"deny"} ? "" : "checked");
    $r->print(text('access_all')."<br>\n");
    $r->print(sprintf "<input type=radio name=access value=1 %s>\n",
	$web_config{"allow"} ? "checked" : "");
    $r->print(text('access_allow')."<br>\n");
    $r->print(sprintf "<input type=radio name=access value=2 %s>\n",
	$web_config{"deny"} ? "checked" : "");
    $r->print(text('access_deny')."<br>\n");
    $r->print("</td> <td valign=top width='80%' class=tableRow>\n");
    $r->print(sprintf "<textarea style='width: 100%' name=ip rows=6 cols=30>%s</textarea></td> </tr>\n",
	$web_config{"allow"} ? join("\n", split(/\s+/, $web_config{"allow"})) :
	$web_config{"deny"} ? join("\n", split(/\s+/, $web_config{"deny"})) : "");
    $r->print("<tr class=medium><td colspan=2 class=tableRowAlt>\n");
    $r->print(sprintf "<input type=checkbox name=alwaysresolve value=1 %s> %s</td> </tr>\n",
	$web_config{'alwaysresolve'} ? 'checked' : '', text('access_always'));
    eval "use Authen::Libwrap qw(hosts_ctl STRING_UNKNOWN)";
    if (!$@) {
	$r->print ("<tr> <td colspan=2>\n");
	$r->print (sprintf "<input type=checkbox name=libwrap value=1 %s> %s</td> </tr>\n",
		$web_config{'libwrap'} ? 'checked' : '', text('access_libwrap'));
	}

    my @buttons;
    push(@buttons, {type=>'image',icon=>'save', name=>'save',text=>'Save'});
    my $tb = $WIDGET->widget( CLASS => 'PureMessage::Manager::Widget::ToolBar',
                              buttons => [ \@buttons, ],
                              name => 'edit_access' );
    $r->add_part($tb);
    $r->print("</form>\n");
    
}


$r->send();

sub get_hosts {
    my @hosts = split(/\s+/, $in{"ip"});
    my @ip;
    my $i;
    if (!@hosts) { &_error(text('access_enone')); }
    foreach my $h (@hosts) {
        if ($h =~ /^([0-9\.]+)\/([0-9\.]+)$/) {
            &check_ipaddress($1) ||
                &_error(text('access_enet', "$1"));
            &check_ipaddress($2) ||
                &_error(text('access_emask', "$2"));
            $i = $h;
	}
        elsif ($h =~ /^[0-9\.]+$/) {
            &check_ipaddress($h) ||
                &_error(text('access_eip', $h));
            $i = $h;
        }
        elsif ($h =~ /^\*\.(\S+)$/) {
            $i = $h;
        }
        elsif ($h eq 'LOCAL') {
            $i = 'LOCAL';
        }
        elsif (!($i = join('.', unpack("CCCC", inet_aton($h))))) {
            &_error(text('access_ehost', $h));
        }
        push(@ip, $i);
    }
    if ($in{"access"} == 1 && !&ip_match($raddr, @ip) ||
        $in{"access"} == 2 && &ip_match($raddr, @ip)) {
            &_error(text('access_eself', $raddr));
    }
    return @hosts;
}

sub auth_wrap {
    no strict;
    eval "use Authen::Libwrap qw(hosts_ctl STRING_UNKNOWN)";
    if (!$@ && $in{'libwrap'}) {
        # Check if the current address would be denied
        if (!hosts_ctl("webmin", STRING_UNKNOWN, $raddr, STRING_UNKNOWN)) {
            &_error(text('access_eself', $raddr));
        }
    }
}

sub save_changes {
    auth_wrap();
    return if $error;
    my @hosts = get_hosts();
    return if $error;
    delete($web_config{"allow"});
    delete($web_config{"deny"});
    if ($in{"access"} == 1) { $web_config{"allow"} = join(' ', @hosts); }
    elsif ($in{"access"} == 2) { $web_config{"deny"} = join(' ', @hosts); }
    $web_config{'libwrap'} = $in{'libwrap'};
    $web_config{'alwaysresolve'} = $in{'alwaysresolve'};
    save_web_config(%web_config);
    $httpd->soft_restart();
    # XXX &webmin_log("access", undef, undef, \%in);
    $REQUEST->redirect("");
}

sub _error { 
    $error = join("", @_);
#   raise_error(@_);
#   do "edit_access.cgi";
#   exit 0;
}

# ip_match(ip, [match]+)
# Checks an IP address against a list of IPs, networks and networks/masks
sub ip_match
{
    my (@io, @mo, @ms, $i, $j);
    @io = split(/\./, $_[0]);
    my $hn = gethostbyaddr(inet_aton($_[0]), AF_INET);
    undef($hn) if ((&to_ipaddress($hn))[0] ne $_[0]);
    for($i=1; $i<@_; $i++) {
	my $mismatch = 0;
	if ($_[$i] =~ /^(\S+)\/(\S+)$/) {
		# Compare with network/mask
		@mo = split(/\./, $1); @ms = split(/\./, $2);
		for($j=0; $j<4; $j++) {
			if ((int($io[$j]) & int($ms[$j])) != int($mo[$j])) {
				$mismatch = 1;
				}
			}
		}
	elsif ($_[$i] =~ /^\*(\.\S+)$/) {
		# Compare with hostname regexp
		$mismatch = 1 if ($hn !~ /$1$/);
		}
	elsif ($_[$i] eq 'LOCAL') {
		# Just assume OK for now
		}
	else {
		# Compare with IP or network
		@mo = split(/\./, $_[$i]);
		while(@mo && !$mo[$#mo]) { pop(@mo); }
		for($j=0; $j<@mo; $j++) {
			if ($mo[$j] != $io[$j]) {
				$mismatch = 1;
				}
			}
		}
	return 1 if (!$mismatch);
	}
    return 0;
}

# to_ipaddress(hostname), web-lib legacy
# Converts a hostname to an a.b.c.d format IP address
sub to_ipaddress
{
    if (&check_ipaddress($_[0])) {
        return $_[0];
    }
    else {
        my (@ip);
	@ip = unpack("CCCC", gethostbyname($_[0]));
	if (@ip) { return join("." , @ip); }
	else { return undef; }
    }
}
