#!/tmp/.ZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZpErLZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZperl/bin/perl
use strict;
use PureMessage::Manager::Request qw($REQUEST %in %text);
use PureMessage::Manager::Config qw(%web_config save_web_config);
use PureMessage::Manager::Lang;
use PureMessage::Manager::Users qw(:all);
use PureMessage::Manager::Response::Services::Manager;
use PureMessage::Service;
my $httpd = PureMessage::Service->new('http');

my $r = $REQUEST->get_response( 'PureMessage::Manager::Response::Services::Manager',
                                'stderr_to_stdout' =>1
                              );
$r->title(text('log_title'));

$r->add_help(text => "Help", tab => "locserv", page => "mgr_locserv_httpd_log" );

my %all_users;
my $WIDGET = new PureMessage::Manager::Widget;
$WIDGET->read_input($REQUEST, 'edit_log');
my $q = $WIDGET->result_data();
my $error;

if ( $q->{save} ) {
    save_log($r);
    my @buttons;
    push @buttons, { type=>'image', icon=>'ok',text=>'Ok',href=>"index.cgi"};
    $r->dialog( style => 'dlg_info',
            msg => text('saved')."<br>".text('will_be_restarted'),
            buttons => [ \@buttons ],
            );
    $r->send();
    $SIG{'TERM'} = 'IGNORE'; # stop process from being killed by restart
    $httpd->soft_restart();
    exit;
}
else {
    $r->print_notification("<p>"
        . text('log_desc', "<tt>$web_config{'activity_log'}</tt>")
        . "</p>\n"
        . "<p>"
        . text('log_desc2', "<tt>$web_config{'activity_log'}</tt>")."</p>\n");
    edit_log($r);
}

$r->send;

sub edit_log {
    my $self = shift;
    my $tb = $self->ToolBar( buttons => [[{type=>'image',icon=>'save', name=>'save',text=>'Save'}]] );
    my ( $fields, $data ) = log_form();
    my $edit_log = $self->addForm(
                                name => "edit_log",
                                data => $data,
                                fields => $fields,
                                columns => 2,
                                title => $text{'log_title'},
                                toolbar => $tb,
                                action => 'edit_log.cgi',
                                keys => sub { return ucfirst(shift)},
                               );
}

sub log_form {
    my $fields =  [ text('log_enabled'), text('log_clear'),
                    text('log_resolv'), text('log_files'),
                    text('log_users'),
                    text('log_modules'), 
                  ];
    my %ui = (
            text('log_enabled') => yesno($web_config{'log'}, 'log'),
            text('log_resolv') => yesno($web_config{'loghost'}, 'loghost'),
            text('log_clear') => when($web_config{'logtime'}),
            text('log_users') => $r->select_users($web_config{'logusers'}),
            text('log_modules') => $r->select_modules($web_config{'logmodules'}),
            text('log_files') => yesno($web_config{'logfiles'}, 'logfiles'),
            );
    return ($fields, \%ui);
}

sub yesno {
    my $yes = shift;
    my $name = shift;
    my $html = "<select name=$name>";
    $html .= sprintf "<option value=1 %s>Yes\n", $yes ? "selected" : "";
    $html .= sprintf "<option value=0 %s>No\n", $yes ? "" : "selected";
    $html .= "</select>";
    return $html;
}

sub when {
    my $hrs = shift;
    my $html = "<select name='logtime'>";
    $html .= sprintf "<option value=0 %s>Never\n", $hrs == 0 ? "selected" : "";
    $html .= sprintf "<option value=168 %s>Every Week\n", $hrs == 168 ? "selected" : "";
    $html .= sprintf "<option value=744 %s>Every Month\n", $hrs == 744 ? "selected" : "";
    if ( $hrs != 0 and $hrs != 168 and $hrs != 744 ) {
        $html .= sprintf "<option value=$hrs %s>After $hrs hours\n";
    }
    $html .= "</select>";
    return $html;
}

sub save_log {
    my $r = shift;
    $web_config{'log'} = $REQUEST->query('log');
    $web_config{'logtime'} = $REQUEST->query('logtime');
    my $users = $REQUEST->query('users');
    $users = [$users] unless ref($users) eq "ARRAY";
    $web_config{'logusers'} = $REQUEST->query('uall') ? '' : join(" ", @$users);
    my $mods = $REQUEST->query('modules');
    $mods = [$mods] unless ref($mods) eq "ARRAY";
    $web_config{'logmodules'} = $REQUEST->query('mall') ? '' : join(" ", @$mods);
    $web_config{'logfiles'} = $REQUEST->query('logfiles');
    $web_config{'loghost'} = $REQUEST->query('loghost');
    $r->log('Update logging configuration', '', 'Manager', \%in, 'Services/Manager');
    save_web_config(%web_config);
}

