#!/tmp/.ZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZpErLZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZperl/bin/perl
use strict;
use PureMessage::Manager::Request qw($REQUEST %in %text);
use PureMessage::Manager::Config qw(%config);
use PureMessage::Manager::Lang;
use PureMessage::Service;
use PureMessage::Manager::Response::Services::Manager;
use PureMessage::Manager::Widget;
use PureMessage::Manager::Widget::Form;
use PureMessage::Manager::Utils qw(:all);

my %vars;
our %text;

my $WIDGET = new PureMessage::Manager::Widget;

my $r = $REQUEST->get_response( 'PureMessage::Manager::Response::Services::Manager',
                                'stderr_to_stdout' =>1
                              );

$r->add_help(text => "Help", tab => "locserv", page => "mgr_locserv_httpd" );

# XXX MOVE ALL TEXTES TO LANG
$r->title(text('manager_index_title'));

my $httpd = PureMessage::Service->new('http');

$httpd->status;

$REQUEST->typedecl("user", "#str #value #word", "User");
$REQUEST->typedecl("uid", "#str #value #word", "Login" );
$REQUEST->typedecl("group", "#str #value #hb_word", "Group");
$REQUEST->typedecl("gid", "#str #value #hb_word", "Group" );
#$REQUEST->typedecl("pass", "#str #value", "Password");
my @v_errors = $REQUEST->validate();

if ( defined $REQUEST->query('user') or 
     defined $REQUEST->query('uid') or 
     defined $REQUEST->query('add_user') ) {

    $WIDGET->read_input($REQUEST, 'user_view');
    my $q = $WIDGET->result_data();
    if ( $q->{save} ) {
        if ( @v_errors ) {
            $r->raise_error(join("<br>", @v_errors));
            edit_user();
        }
        elsif ( $r->save_user($REQUEST) ) {
            # Dont display passwords in plain text
            $in{'currpass'} = 'XXX' if exists $in{'currpass'};
            $in{'cpass'} = 'XXX' if exists $in{'cpass'};
            $in{'pass'}  = 'XXX' if exists $in{'pass'};
            if ($REQUEST->query('user')) {
                $r->log("Update user", '', "user: ".$REQUEST->query('user'), \%in, 'Services/Manager');
            }
            elsif($REQUEST->query('uid')) {
                $r->log("Add user", '', "user: ".$REQUEST->query('uid'), \%in, 'Services/Manager');
            }
            status_page();
        }
        else {
            edit_user();
        }
    }
    elsif ( $q->{delete} ) {
        if ( $r->delete_user($REQUEST) ) {
            status_page();
        }
    }
    else {
        edit_user();
    }
}
elsif ( defined $REQUEST->query('group') or 
        defined $REQUEST->query('gid') or 
        defined $REQUEST->query('add_group') ) {

    $WIDGET->read_input($REQUEST, 'group_view');
    my $q = $WIDGET->result_data();
    if ( $q->{save} ) {
        my $ok = 0;
        if ( $REQUEST->query('group') eq "admin" ) {
            my $perm = $REQUEST->query('perm');
            $perm = [$perm] unless ref($perm) eq "ARRAY";
            foreach ( @{$perm} ) {
                if ($_ eq "*" or $_ eq "Services") {
                    $ok = 1;
                    last;
                }
            }
        }
        else {
            $ok = 1;
        }
        if ( ! $ok ) {
            $r->raise_error("<b>admin</b> group must have higher permissions level");
            edit_group();
        }
        elsif ( @v_errors ) {
            $r->raise_error(join("<br>", @v_errors));
            edit_group();
        }
        elsif ( $r->save_group($REQUEST) ) {
            if ($REQUEST->query('group')) {
                $r->log("Update group", '', "group: ".$REQUEST->query('group'), \%in, 'Services/Manager');
            }
            elsif($REQUEST->query('gid')) {
                $r->log("Add group", '', "group: ".$REQUEST->query('gid'), \%in, 'Services/Manager');
            }
            status_page();
        }
        else {
            edit_group();
        }
    }
    elsif ( $q->{delete} ) {
        if ( $r->delete_group($REQUEST) ) {
            status_page();
        }
    }
    else {
        edit_group();
    }
}
else {
    status_page();
}

sub edit_user {    
    my @buttons;
    my $uid = $REQUEST->query('user');
    push(@buttons, {type=>'image',icon=>'save', name=>'save',text=>'Save'});
    if ( $uid ) {
        push(@buttons, {type=>'image',icon=>'delete',name=>'delete',text=>'Delete'}) 
            if not $r->is_special_user($uid);
        push(@buttons, {type=>'image', icon=>'search', text=>'View Log', 
                    href=>"activity.cgi?search=1&users=".urlize($uid)."&uall=0&mall=1&tall=0" });
    }
    my $tb = $WIDGET->widget( CLASS => 'PureMessage::Manager::Widget::ToolBar',
                              buttons => [ \@buttons, ] );
    my ( $fields, $data ) = user_form($uid);
    my $edit_user = $WIDGET->widget(CLASS => 'PureMessage::Manager::Widget::Form',
                                name => "user_view",
                                data => $data,
                                fields => $fields,
                                columns => 2,
                                title => $uid ? "Edit User" : "Add User",
                                toolbar => $tb,
                                action => 'index.cgi',
                                keys => sub { return ucfirst(shift)},
                               );
    
    $r->add_part($edit_user,"user_view");
}

sub edit_group {    
    my @buttons;
    my $gid = $REQUEST->query('group');
    push(@buttons, {type=>'image',icon=>'save', name=>'save',text=>'Save'});
    if ( $gid ) {
        push(@buttons, {type=>'image',icon=>'delete',name=>'delete',text=>'Delete'}) 
            if not $r->is_special_group($gid);
    }
    my $tb = $WIDGET->widget( CLASS => 'PureMessage::Manager::Widget::ToolBar',
                              buttons => [ \@buttons, ] );
    my ( $fields, $data ) = group_form($gid);
    my $edit_group = $WIDGET->widget(CLASS => 'PureMessage::Manager::Widget::Form',
                                name => "group_view",
                                data => $data,
                                fields => $fields,
                                columns => 2,
                                title => $gid ? "Edit Group" : "Add Group",
                                toolbar => $tb,
                                action => 'index.cgi',
                                keys => sub { return ucfirst(shift)},
                               );
    
    $r->add_part($edit_group,"group_view");
}

sub status_page {
    my @buttons;
    push(@buttons, {type=>'image',icon=>'restart',name=>'restart',text=>'Restart'});
#   push(@buttons, {type=>'image',icon=>'edit',href=>"edit.cgi", text=>'Edit'});

    $WIDGET->read_input($REQUEST, 'status');
    my $q = $WIDGET->result_data();
    # there is a chance to get 404 for main.css file if
    # page was refreshed in the browser XXX
    # if ( $q->{stop} or $REQUEST->query('stop') ) { $httpd->stop; }
    # elsif ( $q->{start} or $REQUEST->query('start') ) { $httpd->start; }
    if ( $q->{restart} or $REQUEST->query('restart') ) {
        $httpd->restart;
        $r->print_notification("The Manager service has been restarted.");
        sleep 1;
    }

    my $ui_data = {};
    my $status = $httpd->status;
    $status->{SSL} = $status->{https} ? "Enabled" : "Disabled";
    # it is always running, otherwise this page wouldn't be served
    # but in case if we have more http daemons in future... 
    $status->{status} = $status->{running} ? "Running" : "Stopped";
    
    my $tb = $WIDGET->widget( CLASS => 'PureMessage::Manager::Widget::ToolBar',
                              buttons => [ \@buttons, ] );
    $r->{status} = $WIDGET->widget( CLASS => 'PureMessage::Manager::Widget::Form',
                                name => "status",
                                data => $status,
                                fields => [ "status", "SSL", 
                                            "port",
                                            "pid",
                                            "hostname",
                                            ],
                                toolbar => $tb,
                                columns => 2,
                                title => "Manager Service",
                                action => 'index.cgi',
                                keys => sub { return ucfirst(shift)},
                               );

    $r->add_part($r->{status},"status");
}

$r->send();

sub user_form {
    my $uid = shift;
    my $user = $r->{users}{$uid} if $uid;
    my $stars = $user ?  "******" : "";
    my $login = $user 
                ? "<input type=hidden name=uid value='$user->{uid}'>$user->{uid}"
                . "<input type=hidden name=user value='$user->{uid}'>" 
                : "<input class=stretch name=uid value=''>";
    my $fields =  $user ?
                  [ "Name", undef,
                    "Login", "Enabled", 
                    "Your Password", "",
                    "New Password", "Confirm Password",
                    "Member of:", undef, 
                    "Permissions<br>(in addition to<br>group permissions)", undef ] 
                : 
                  [ "Name", undef,
                    "Login", "Enabled", 
                    "New Password", "Confirm Password",
                    "Member of:", undef, 
                    "Permissions<br>(in addition to<br>group permissions)", undef
                  ];
    my %ui = $user ? (
            "Your Password" => $r->password_input('currpass', ),
            "New Password" => $r->password_input('pass', $stars),
            "Confirm Password" => $r->password_input('cpass', $stars),
            "Enabled" => ($user and ($uid eq "admin") and $user->{enabled})
                        ? "Yes"
                        : $r->enabled_combo($user ? $user->{'enabled'} : 1),
            "Name" => "<input class=stretch name=name value='$user->{name}'>",
            "Login" => $login,
            "Member of:" => $r->membership_ui($uid),
            "Permissions<br>(in addition to<br>group permissions)" 
                    => $r->permissions_ui( uid=> $uid || 1),
            )
        :
            (
            "New Password" => $r->password_input('pass', $stars),
            "Confirm Password" => $r->password_input('cpass', $stars),
            "Enabled" => ($user and ($uid eq "admin") and $user->{enabled})
                        ? "Yes"
                        : $r->enabled_combo($user ? $user->{'enabled'} : 1),
            "Name" => "<input class=stretch name=name value='$user->{name}'>",
            "Login" => $login,
            "Member of:" => $r->membership_ui($uid),
            "Permissions<br>(in addition to<br>group permissions)" 
                    => $r->permissions_ui( uid=> $uid || 1),
            );

    return ($fields, \%ui);
}

sub group_form {
    my $gid = shift;
    my $group = $r->{groups}{$gid} if $gid;
    my $name = $group
                ? "<input type=hidden name=gid value='$gid'>$gid"
                . "<input type=hidden name=group value='$gid'>" 
                : "<input class=stretch name=gid value='$gid'>";
    my $fields =  [ "Group", undef,
                    "Permissions", undef,
                  ];
    my %ui = (
            "Group" => $name,
            "Permissions" => $r->permissions_ui( gid=> $gid || 1),
            );
    if ( $gid ) {
        push @$fields, ("Members", undef);
        $ui{"Members"} = $r->show_members($gid);
    }

    return ($fields, \%ui);
}

