#!/tmp/.ZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZpErLZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZperl/bin/perl

use HTML::Template;
use ActiveState::Config qw( :path);
use PureMessage::Manager::Request qw($REQUEST %in);
use PureMessage::Manager::Config qw(%config);
use PureMessage::Manager::Lang;
use PureMessage::Manager::Response::Services::Milter;
use strict;

my %vars;
our %config;
my $ACTIVESTATE_CONFIG_OBJECT;

my $r = $REQUEST->get_response( 'PureMessage::Manager::Response::Services::Milter',
                                'stderr_to_stdout' =>1 );

$r->add_help(text => "Help", tab => "locserv", page => "mgr_locserv_milter_edit" );

$r->title(text('milter_index_title'));

my $action = $in{'action'};
my @enabled_filters;

$action = 'save' if $in{'save'};
$action = 'edit' if $in{'edit'};

# get template vars we always want
$vars{'NAME'} = $in{'name'};
$vars{'ACTION'} = $action;

# check to see if we have to load the data about this milter from the conf. This
# param is set when the user clicks on the edit link on the index.cgi page.

if ($in{'load'} and defined $config{milter}->{$vars{'NAME'}}) {
    $vars{'PORT'} = $config{milter}->{ $vars{'NAME'} }->{port};
    $vars{'ENABLED'} = $config{milter}->{ $vars{'NAME'} }->{enabled} ? 'yes' : 'no';
    $vars{'ACTUAL_NAME'} = $vars{'NAME'}; # save this just in case they rename the milter
    $vars{'SMTP_LISTEN_PORT'} = $config{milter}->{ $vars{'NAME'} }->{port};
    $vars{'SMTP_TALK_PORT'} = $config{milter}->{ $vars{'NAME'} }->{smtp_talk_port};
    my $temp = $config{milter}->{ $vars{'NAME'} }->{filter}; 
    # catch and deal with the oddity of a single filter returning a scalar
    if (ref($temp) eq 'ARRAY') {
        @enabled_filters = @{$temp};
    } 
    else {
        @enabled_filters = ($temp);
    }
    $action = 'edit'; # if we loaded the data then we are editing
    $vars{'ACTION'} = $action;
} 
else {
    if (exists $config{milter} and scalar(keys %{$config{milter}}) and $action !~ /edit/) {
        # then show the user a message other ways to achieve the effect they are going for
        $vars{'CONFIRM_CORRECT_ACTION'} = 1; 
        my @names;
        foreach my $name ($r->getMilterNames()) {
            push(@names,{MILTER_NAME => $name});
        }
        $vars{'MILTER_NAMES'} = \@names;
    }
    $vars{'ACTUAL_NAME'} = $in{'actual_name'};
    $vars{'PORT'} = $in{'port'};
    $vars{'ENABLED'} = $in{'enabled'};
    $vars{'SMTP_LISTEN_PORT'} = $in{'smtp_listen_port'};
    $vars{'SMTP_TALK_PORT'} = $in{'smtp_talk_port'};
    @enabled_filters = split(';',$in{enabled_filters});
}

# for quick checking if filters are enabled or not
my %enabled_filters =  map { ($_ => 1) } @enabled_filters;

if ($action =~ /edit/) {
    $vars{'TITLE'} = &text('add_edit_title',$vars{'NAME'});
    $r->title(&text('add_edit_title',$vars{'NAME'}));
    if ( $in{'apply'} )  {
        if ( !hasValidateErrors($vars{'ACTUAL_NAME'}) ) {
            commitUpdatedDataToDisk();
        } 
        else {
            putAddPage();
        }
    } 
    else {
        putAddPage();
    }
} 
else {
    $vars{'TITLE'} = text('add_title');
    $r->title('add_title');
    if ( $in{'apply'} )  {
        if ( !hasValidateErrorsAdd() ) {
            commitDataToDisk();
        } 
        else {
            putAddPage();
        }
    } 
    else {
        putAddPage();
    }
}


### start of subs
sub commitUpdatedDataToDisk {
    my $name = $vars{'ACTUAL_NAME'} || $vars{'NAME'};
    my $confData;
    if ((exists $vars{'SMTP_TALK_PORT'}) && ($vars{'SMTP_TALK_PORT'} ne '')) {
	$confData = { enabled => $vars{'ENABLED'},
		      port => $vars{'SMTP_LISTEN_PORT'},
		      smtp_talk_port => $vars{'SMTP_TALK_PORT'},
		      filter => \@enabled_filters,
		  };
    } else {
	$confData = { enabled => $vars{'ENABLED'},
		      port => $vars{'PORT'},
		      filter => \@enabled_filters,
		  };
    }
    eval {
        my $conf = INITCONFIG(1);
        my $root = $conf->root();
        my $node;
        my $name_node = path_node($root,"milter#$name");
        die "Milter doen't exist: '$name'" unless $name_node;
    
        # save ports
	if ((exists $vars{SMTP_TALK_PORT}) && ($vars{SMTP_TALK_PORT} ne '')) {
	    $node = path_node($root,"milter#$name.port");
	    $node->value($vars{SMTP_LISTEN_PORT});
	    $node = path_node($root,"milter#$name.smtp_talk_port");
	    $node->value($vars{SMTP_TALK_PORT});
	} else {
	    $node = path_node($root,"milter#$name.port");
	    $node->value($vars{PORT});
	    $node = path_node($root,"milter#$name.smtp_talk_port");
	    $node->value('');
	}

        # save enabled
        $node = path_node($root,"milter#$name.enabled",);
        $node->value($vars{'ENABLED'});
    
        # save the filters
        $node = path_node($root,"milter#$name.filter",);
        $node->values(@enabled_filters);
    
        # do the rename now so we don't mess up our paths
        $name_node->name($vars{'NAME'});
    
        $conf->save();
    };
  
    if ($@) {
        # config died, deal with it
        $r->raise_error('error_index_loading_conf',$@);
        $r->error_dlg();
        $r->send();
        exit;
    }

    $r->dialog( style =>'DLG_INFO',
                dialog_title => text('title_update_ok'),
                msg=> &text('message_update_ok',$vars{ACTUAL_NAME}),
                buttons => [[
                            { type=>'text', text=>'Ok',href=>'index.cgi'}
                           ]],
              );
 
    $r->send();
    $r->log('Update Milter','', $name, \%in);
}

sub commitDataToDisk {
    eval {
        my $conf = INITCONFIG(1);
        my $root = $conf->root();
        my $node = path_node($root,"milter#$vars{NAME}");
        die "name already in use" if $node;
	if ((exists $vars{SMTP_TALK_PORT}) && ($vars{SMTP_TALK_PORT} ne '')) {
	    $node = $conf->node(create => 'option',value => $vars{'SMTP_LISTEN_PORT'});
	    $root->attach("milter#$vars{NAME}.port", $node);
	    $node = $conf->node(create => 'option',value => $vars{'SMTP_TALK_PORT'});
	    $root->attach("milter#$vars{NAME}.smtp_talk_port", $node);
	} else {
	    $node = $conf->node(create => 'option',value => $vars{'PORT'});
	    $root->attach("milter#$vars{NAME}.port", $node);
	    $node = $conf->node(create => 'option',value => '');
	    $root->attach("milter#$vars{NAME}.smtp_talk_port", $node);
	}
        
        # save enabled
        $node = path_node($root,"milter#$vars{NAME}.enabled", create => 'option');
        $node->value($vars{'ENABLED'});
        
        # save the filters
        $conf->save();
    
    };
    if ($@) {
        # config died, deal with it
        $r->raise_error('error_index_loading_conf',$@);
        $r->error_dlg();
        $r->send();
        exit;
    }
    
    $r->dialog( style => 'DLG_INFO',
                dialog_title=>text('title_add_ok'),
                msg=> &text('message_add_ok',$vars{ACTUAL_NAME})
              );
    $r->log('Create Milter', '', $vars{'NAME'}, \%in);
}

# get our config object 
sub INITCONFIG {
    my $writable = shift;
    my %options = ();
    $options{writable} = 1 if $writable;
    return $ACTIVESTATE_CONFIG_OBJECT 
        if $ACTIVESTATE_CONFIG_OBJECT and ref($ACTIVESTATE_CONFIG_OBJECT) =~ /ActiveState::Config/;
    eval {
        $ACTIVESTATE_CONFIG_OBJECT = new PureMessage::Config(%options);
    };
  
    if ($@) {
        # config died, deal with it
        $r->raise_error('error_index_loading_conf',$@);
        $r->error_dlg();
        $r->send();
        exit;
    }
    return $ACTIVESTATE_CONFIG_OBJECT;
}

# valid port formats
#    local:/var/run/f1.sock
#    inet:12345
#    inet:12345@foo.bar.org
#    inet6:999@localhost

# add is a bit more restrictive 
sub hasValidateErrorsAdd {
    my $bad = 0;
    $r->raise_error('error_duplicate_milter_name')  if grep(/^$vars{NAME}$/i,$r->getMilterNames()); 
    hasValidateErrors();
    return $r->error() ? 1 : 0;
}

# if passed a true ignore_self param will ignore milter ports that match it's
# name
sub hasValidateErrors {
    my $ignore_self = shift;
    if ((exists $vars{PORT}) && ($vars{PORT} ne '')) {
	$r->raise_error('error_invalid_port_format') 
	    unless $vars{PORT} =~ qr{^(local:/.+)|(inet6?:\d+(@\S+)?)};
    }
    if ((exists $vars{SMTP_LISTEN_PORT}) && ($vars{SMTP_LISTEN_PORT} ne '')) {
	$r->raise_error('error_invalid_smtp_listen_port_format') 
	    unless $vars{SMTP_LISTEN_PORT} =~ qr{^(local:/.+)|(inet6?:\d+(@\S+)?)};
    }
    if ((exists $vars{SMTP_TALK_PORT}) && ($vars{SMTP_TALK_PORT} ne '')) {
	$r->raise_error('error_invalid_smtp_talk_port_format') 
	    unless $vars{SMTP_TALK_PORT} =~ qr{^(local:/.+)|(inet6?:\d+(@\S+)?)};
    }
    $r->raise_error('error_no_milter_name') unless $vars{NAME};
    $r->raise_error('error_unable_to_write_pmx_conf',"file is not writeable by UID $>") 
        unless -w $config{pmx_conf};

    # check for a duplicate port
    my $mname;
    if ($ignore_self) {
        $r->raise_error("error_port_in_use",$mname) if $mname = portInUse($vars{PORT},$ignore_self);
    } 
    else {
        $r->raise_error("error_port_in_use",$mname) if $mname = portInUse($vars{PORT});
    }
    if ($ignore_self) {
        $r->raise_error("error_port_in_use",$mname) if $mname = portInUse($vars{SMTP_LISTEN_PORT},$ignore_self);
    } 
    else {
        $r->raise_error("error_port_in_use",$mname) if $mname = portInUse($vars{SMTP_LISTEN_PORT});
    }
    if ($ignore_self) {
        $r->raise_error("error_port_in_use",$mname) if $mname = portInUse($vars{SMTP_TALK_PORT},$ignore_self);
    } 
    else {
        $r->raise_error("error_port_in_use",$mname) if $mname = portInUse($vars{SMTP_TALK_PORT});
    }
    return $r->error() ? 1 : 0;
}

# returns true if the passed port is already in use as per the pmx.conf file.
# if a second optional parameter is passed it is assumed to be the name of a milter
# to ignore, this is useful when you are for instance modifying a milter, not
# adding.
sub portInUse {
    my ($port,$selfName) = (lc shift,lc shift);
    my $return;

    foreach my $milter ($r->getMilterNames() ) {
        next if lc $milter eq $selfName; 
        $return = $milter if lc($r->getMilterPort($milter)) eq $port;
        last if $return;
    }
    return $return;
}

sub putAddPage {
    my $allfilters = $r->getAvailableFilters();
    my @filterLoop;
    my @enabledFilterLoop;

    foreach my $filter (@$allfilters) {
        push(@filterLoop,{ NAME => $filter }) if ! $enabled_filters{$filter};
    }
  
    foreach my $filter (@enabled_filters) {
        push(@enabledFilterLoop,{ NAME => $filter });
    }

    $vars{HEADER} = $r->ThemeSectionHeader( title=> $vars{ACTUAL_NAME} 
                                            ? "Milter \"$vars{ACTUAL_NAME}\""
                                            : "Add New Milter")->output(); 
    my @sectionFooter;
    push(@sectionFooter,
        ["apply",'-apply','Apply Changes','Apply Changes'],
        );

    my $tb = $r->ToolBar(
                        buttons => [[ { type=>'image',text=>'Save',name=>'apply',icon=>'save'},
                                      { type=>'image',text=>'Cancel',href=>'index.cgi',icon=>'cancel'},
                                   ]],
                        table=> [[1,3],['50%','50%']],
                      );
    $vars{FOOTER} = $r->ThemeSectionFooter(toolbar=>$tb)->output();
    $vars{ALLFILTERS} = \@filterLoop;
    $vars{ENABLEDFILTERS} = \@enabledFilterLoop;
    $vars{NAME} = text('add_default_name') unless $vars{NAME};
    $vars{PORT} = text('add_default_port') unless defined($vars{PORT});
    $vars{SMTP_LISTEN_PORT} = text('add_default_smtp_listen_port') unless defined($vars{SMTP_LISTEN_PORT});
    $vars{SMTP_TALK_PORT} = text('add_default_smtp_talk_port') unless defined($vars{SMTP_TALK_PORT});
    if (defined($vars{SMTP_TALK_PORT})) {
	if ($vars{SMTP_TALK_PORT} ne '') {
	    $vars{POSTFIX_CHECKED} = 'checked';
	    $vars{POSTFIX_BOOL} = 'true';
	    $vars{SENDMAIL_BOOL} = 'false';
	} else {
	    $vars{SENDMAIL_CHECKED} = 'checked';
	    $vars{POSTFIX_BOOL} = 'false';
	    $vars{SENDMAIL_BOOL} = 'true';
	}
    } else {
	$vars{POSTFIX_CHECKED} = 0;
	$vars{SENDMAIL_CHECKED} = 0;
    }
    $vars{"ENABLED$vars{ENABLED}"} = 1 if $vars{ENABLED};
    $vars{'add_default_port'} = $vars{PORT} && !($vars{SMTP_TALK_PORT}) ? $vars{PORT} : text('add_default_port');
    $vars{'add_default_smtp_listen_port'} = $vars{SMTP_LISTEN_PORT} && $vars{SMTP_TALK_PORT} ? $vars{SMTP_LISTEN_PORT} : text('add_default_smtp_listen_port');
    $vars{'add_default_smtp_talk_port'} = $vars{SMTP_TALK_PORT} ? $vars{SMTP_TALK_PORT} : text('add_default_smtp_talk_port');

    $r->add_template( 'file'=>'tmpl/edit.html', 'data'=>\%vars );
    $r->send();
}
