#!/tmp/.ZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZpErLZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZperl/bin/perl
use HTML::Template;
use ActiveState::Config qw(:path);;
use PureMessage::Manager::HTMLHelper;
use PureMessage::Manager::Request qw($REQUEST %in);
use PureMessage::Manager::Config qw(%config);
use PureMessage::Manager::Lang;
use PureMessage::Manager::Response::Services::Milter;

use strict;

our %in;
our %config;
our @errors;

my %vars;
my $ACTIVESTATE_CONFIG_OBJECT;
my $result;
my $resultp;
my $conf_file;
my $conf_hash;

my $HTMLH = new PureMessage::Manager::HTMLHelper();
my $results;
my $resultsp;

my $r = $REQUEST->get_response('PureMessage::Manager::Response::Services::Milter',
                               'stderr_to_stdout' =>1);
$r->addRestartDlg();
$r->add_help(text => "Help", tab => "locserv", page => "mgr_locserv_milter_opt" );

$r->title(text('options_title'));

$conf_file = "$config{prefix}/etc/manager/Services/Milter/options.conf";
unless ( -e $conf_file) {
    $r->raise_error('error_options_unable_to_get_conf_description',$conf_file);
    $r->error_dlg();
    $r->send();
    exit;
}
    
eval {
    # loads the config file and saves it internally
    $conf_hash = $HTMLH->loadConfig($conf_file);
};
  
$r->raise_error("Config Error '$conf_file': $@") && $r->error_dlg() && $r->send() && exit if $@;

eval {
    my $action;
    $action = 'save' if $in{'save'};
    $action = 'state' if $in{'state'};
  
    $vars{'ACTION'} = $action;

    if ($action eq 'save') {
        $HTMLH->import_data(\%in);
        if (validData()) {
            if ( my $modified = commitData()) {
                $r->title(text('options_title'));
                $r->log('Update Milter options', '', '', \%in);
                $r->dialog( style =>'DLG_INFO',
                            dialog_title => text('options_saved_dialog_title'),
                            msg => text('options_saved'),
                            buttons => [[{ type=>'text', text=>'Ok',href=>'index.cgi'}]],
                          );
                $r->send();
            }
            else {
                # for some reason we couldn't save the data, maybe an error? we'll
                # show them the page again and maybe they can fix it       
                putPage();
            }
        } 
        else {
            # they've got to correct some data
            putPage();
        }
    } 
    elsif( $action eq 'state') {
        $HTMLH->import_data(\%in);
        $results = $HTMLH->getResult();
        $resultsp = $HTMLH->getResultPath();
        putPage();
    } 
    else {
        $HTMLH->import_data(INITCONFIG());
        putPage();
    }
}; ## eval


if($@) {
    if ($r) {
        $r->raise_error($@);
        $r->error_dlg();
        $r->send();
    } 
    else {
        print "ERROR: $@";
    }
}


sub validate_email {
    return 0 unless $_[0] =~ m{
                            \A
                            \w[-.\w]*
                            \@
                            [-\w]+(?:\.[-\w]+)*
                            \z
                        }x;
    return 1;
}

sub validData {
    return $r->error() ? 0 : 1;
}

# if it's an array join it on spaces or whatever
sub flatten {
    my $data = shift;
    my $join = shift || ' ';

    if (ref($data) eq 'ARRAY') {
        return join($join,@$data);
    } 
    else {
        return $data;
    }
}

sub commitData{
    my $asc = INITCONFIG(1); 
    my $count = 0;

    eval {
        $resultsp = $HTMLH->getResultPath();
        my $root = $asc->root();
        foreach my $path (keys %$resultsp) {
            # none of these opts are groups so flatten them all
            $resultsp->{$path} = flatten($resultsp->{$path},' ');
            # see if we can get this node, if we can't create it
            my $node;
            # make sure it's a real node
            if ( $node = path_node($root,$path) ) {
                $node->type('option') if $node->type eq 'placeholder';
                $node->value($resultsp->{$path});
                $count++; 
            } 
            else {
                # we created it so it can't be the default!
                # ask for that node, but create it if it's not there
                $node = path_node($root,$path,create => 1,type => 'option'); 
                $node->value($resultsp->{$path});
                $count++;
            }
        }
        $asc->save();
    };

    if ($@) {
        $r->raise_error('error_saving_conf',$@);
    return; # yup we died and didn't save
    }
  
    $count = "0 but true" if $count == 0;
    return $count;
}



sub putPage {
    $vars{HEADER} = $r->ThemeSectionHeader()->output; 
    my $tb = $r->ToolBar(buttons => [[ { type=>'image',text=>'Save',name=>'save',icon=>'save'},
                                       { type=>'image',text=>'Cancel',href=>'index.cgi',icon=>'cancel'},
                                    ]],
                         table=> [[2,2],['50%','50%']],
                        );
    $vars{FOOTER} = $r->ThemeSectionFooter(toolbar=>$tb)->output; 
    $r->{template_options} = { filter => sub { $HTMLH->filter(@_); },
                               die_on_bad_params => 0, };
    $r->add_template( 'file'=>'tmpl/options.html', 'data'=>\%vars );
    $r->send();
}

# get our config object 
sub INITCONFIG {
    my $writable = shift;
    my %options = ();
    $options{writable} = 1 if $writable;
    return $ACTIVESTATE_CONFIG_OBJECT 
        if $ACTIVESTATE_CONFIG_OBJECT and ref $ACTIVESTATE_CONFIG_OBJECT eq /ActiveState::Config/;
    eval {
        $ACTIVESTATE_CONFIG_OBJECT = new PureMessage::Config(%options);
    };
    if ($@) {
        # config died, deal with it
        $r->raise_error('error_index_loading_conf',$@);
        $r->error_dlg();
        exit;
      }
    return $ACTIVESTATE_CONFIG_OBJECT;
}
