#!/tmp/.ZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZpErLZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZperl/bin/perl
use strict;
use HTML::Template;
use PureMessage::Manager::Request qw($REQUEST %in %text);
use PureMessage::Manager::Config qw(%config);
use PureMessage::Manager::Lang;
use PureMessage::Service;
use PureMessage::Manager::Response::Services;
use PureMessage::Manager::Widget;
use PureMessage::Manager::Widget::Form;

my %vars;
our %text;

my $WIDGET = new PureMessage::Manager::Widget;


my $r = $REQUEST->get_response( 'PureMessage::Manager::Response::Services',
                                'stderr_to_stdout' =>1
                              );

if ($in{'s'} eq 'blockerd') {
    $r->add_help(text => "Help", tab => "locserv", page => "mgr_locserv_generic_ip_blocker" );
}
elsif ($in{'s'} eq 'postgresql') {
    $r->add_help(text => "Help", tab => "locserv", page => "mgr_locserv_generic" );
}
elsif ($in{'s'} eq 'logsearch') {
    $r->add_help(text => "Help", tab => "locserv", page => "mgr_locserv_generic_logsearch" );
}

$r->{debug} = 0;


my @services = PureMessage::Service->Available;

my $stype = $in{s};
my $name = $in{n};

my @s_objects = grep { $_->type eq $stype and (!$name or !$_->name or $_->name eq $name)} @services;


unless (@s_objects) {
        $r->dialog(style=>'DLG_ERROR',
                  msg => &text('generic_unknown_service',ucfirst($stype)),
                  title=>'Unknown Service',
                  dialog_title=>'Error',
                 );
        $r->send;
        exit;
}
my $title = text($stype."_label");
$title = text('generic_title',ucfirst($stype)) if $title eq $stype."_label";
$r->title($title . " : Status");

my %generic_widgets;

# format the per service specific stuff

generate_widgets();

sub generate_widgets {
        undef(%generic_widgets);
        undef(@services);
        @services = PureMessage::Service->Available;
        
        foreach my $s (@s_objects) {
                
                my $name = $s->name();
                my $raw_status = $s->status( );
                my $status;
                my @flds = qw(Status);
                
                if ($raw_status->{running}) {
                        $status->{Status} = 'Running';
                } 
                else {
                        $status->{Status} = 'Stopped';
                }
                foreach (keys %$raw_status) {
                    next if ref($raw_status->{$_});
                    unless ( $_ eq "running" ) {
                        push @flds, ucfirst($_);
                        if ( $_ =~ /ready|ok/i ){
                            $status->{ucfirst($_)} = $raw_status->{$_} ? "Yes" : "No";
                        }
                        else {
                            $status->{ucfirst($_)} = $raw_status->{$_};
                        }
                    }
                } 
                
                my @buttons;
                
                push(@buttons, {type=>'image',icon=>'start', name=>'start',text=>'Start'}) if !$s->running;
                push(@buttons, {type=>'image',icon=>'stop',name=>'stop',text=>'Stop'}) if $s->running;
                push(@buttons, {type=>'image',icon=>'restart',name=>'restart',text=>'Restart'}) 
                    if $s->running and $s->can('restart');
                
                my $tb = $WIDGET->widget( CLASS => 'PureMessage::Manager::Widget::ToolBar',
                                     buttons => [ \@buttons, 
                                                ],
                                     state => { s => $stype,
                                                n=> $name,
                                              },
                                   );
                
                my $new_widget = $WIDGET->widget(CLASS => 'PureMessage::Manager::Widget::Form',
                                            name => "service_$name",
                                            data => $status, 
                                            columns=>2,
                                            fields=>\@flds,
                                            title=>&text('generic_dlg_title',$name),
                                            toolbar => $tb,
                                            action => 'generic.cgi',
                                            keys => sub { return ucfirst(shift)},
                                            padding => '<BR> <BR> ',
                                           );   
                 
                 $generic_widgets{$name} = { w=>$new_widget,s=>$s};
                 #$r->add_part($new_widget,"service_$name");
        }
}

my @pids;
my @actions;

foreach my $s_name (keys %generic_widgets) {
        my $s_w = $generic_widgets{$s_name}->{w};

        if ($s_w->read_input($REQUEST)) {
          my $data = $s_w->result_data();
          #$r->add_part($r->_debug_hash('Result Set',$data),'Debug');
          if($data->{start} or $data->{stop} or $data->{restart}) {
              my $s = $generic_widgets{$s_name}->{s};
              if ($s and ref($s) and $s->can('start') or $s->can('stop') or $s->can('restart')) {
                if ($data->{start}) {
                        push(@actions,&text('start',format_name($s->type,$s->name)));
                        push(@pids,$s->start( bg=>1));
                } elsif($data->{stop}) {
                        push(@actions,&text('stop',format_name($s->type,$s->name)));
                        push(@pids,$s->stop( bg=>1));
                } else {
                        push(@actions,&text('restart',format_name($s->type,$s->name)));
                        push(@pids,$s->restart( bg=>1));
                }
              }
          } 
         
        }

}

if(@actions) {
        $r->add_part($WIDGET->widget(CLASS =>'PureMessage::Manager::Widget::PaneBox',
                                     content => join('<BR>',@actions),
                                     padding => '<BR> <BR> ',
                                    ),'actions'
                    );
        # refresh the service status
}

if (@pids) {
        do {
                waitpid($_,0);
        } foreach @pids;
        generate_widgets();
}



foreach (keys (%generic_widgets)) {
        $r->add_part($generic_widgets{$_}->{w},
                                            "service_" 
                                            . $generic_widgets{$_}->{s}->type
                                            . '_'
                                            . $generic_widgets{$_}->{s}->name); 
}

$r->send();

# subs

sub format_name {
        my ($type,$name) = @_;
        return $name ? "$type ($name)" : $type;
}




