#!/tmp/.ZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZpErLZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZperl/bin/perl
use HTML::Template;
use ActiveState::Config qw(:path);;
use PureMessage::Manager::HTMLHelper;

use PureMessage::Manager::Request qw($REQUEST %in %text);
use PureMessage::Manager::Config qw(%config);
use PureMessage::Manager::Lang;
use PureMessage::Manager::Response::Services;
use PureMessage::Manager::Widget;

use strict;

our %text;
our %in;
our %config;
our @errors;

my %vars;
my $ACTIVESTATE_CONFIG_OBJECT;
my $result;
my $resultp;
my $conf_file;
my $conf_hash;

my $HTMLH = new PureMessage::Manager::HTMLHelper();
my $results;
my $resultsp;


my $WIDGET = new PureMessage::Manager::Widget;


my $r = $REQUEST->get_response( 'PureMessage::Manager::Response::Services',
                                'stderr_to_stdout' =>1
                              );

$r->add_help(text => "Help", tab => "locserv", page => "mgr_locserv_opt" );

#$r->{debug} = 1;

$r->title(&text('option_title'));


    $conf_file = "$config{prefix}/etc/manager/Services/options.conf";
    unless ( -e $conf_file) {
      $r->raise_error('error_options_unable_to_get_conf_description',$conf_file);
      $r->error_dlg();
      $r->send();
      exit;
    }
    
  eval {
    # loads the config file and saves it internally
    $conf_hash = $HTMLH->loadConfig($conf_file);
  };
  
  $r->raise_error("Config Error '$conf_file': $@") && $r->error_dlg() && $r->send() && exit if $@;

 
  my $fixup_from_config = { mail_sender => \&fixup_from_config,
                            admin => \&fixup_from_config,
                          };
  
  my $fixup_to_config = { mail_sender => \&fixup_to_config,
                          admin => \&fixup_to_config,
                        };


eval {


  my $action;

  $action = 'save' if $in{'save'};
  $action = 'state' if $in{'state'};
  
  $vars{'ACTION'} = $action;

  if ($action eq 'save') {

     $HTMLH->import_data(\%in);

     if (validData()) {
              

        if ( my $modified = commitData()) {
          $r->title(text('option_title'));
          # TODO there is now webmin_log right now
          # webmin_log('update','options','milter',\%in);
          $r->dialog( style =>'DLG_INFO',
                      dialog_title => text('options_saved_dialog_title'),
                     # title => $text{'options_saved_dialog_title'} ,
                      msg => text('options_saved'),
                      buttons => [[
                                        { type=>'text', text=>'Ok',href=>'index.cgi'}
                                 ]],
                    );
          $r->send();
          
        } else {
          # for some reason we couldn't save the data, maybe an error? we'll
          # show them the page again and maybe they can fix it
          #&header($text{'options_title'}, "", undef, 0, 1);
          putPage();
        }

      } else {
        # they've got to correct some data
        putPage();
      }





  } elsif( $action eq 'state') {
    
    $HTMLH->import_data(\%in);
    
    $results = $HTMLH->getResult();
    $resultsp = $HTMLH->getResultPath($fixup_to_config);


    putPage();
    
  } else {

    $HTMLH->import_data(INITCONFIG(),$fixup_from_config);
    putPage();

  }

  DEBUG();

}; ## eval


if($@) {
  if ($r) {
        $r->raise_error($@);
        $r->error_dlg();
        $r->send();
  } else {
        print "ERROR: $@";
  }
}


### start of subs

sub DEBUG {
  #print "<PRE> " . Dumper($results) . "</PRE> ";
  #print "<PRE> " . Dumper($resultsp) . "</PRE> ";
  #print "<PRE> " . Dumper(\%in) . Dumper($conf_hash) . "</PRE> ";
}

# borrowed from Keith's code
sub validate_email {
    return 0 unless $_[0] =~ m{
                            \A
                            \w[-.\w]*
                            \@
                            [-\w]+(?:\.[-\w]+)*
                            \z
                        }x;
    return 1;
}

sub validData {
        $r->raise_error('options_error_mail_sender_server_bad') unless
                $HTMLH->getMappedValue('mail_sender_server') =~ /^[-\w\.]+$/;

        $r->raise_error('options_error_mail_sender_port_bad') unless
                $HTMLH->getMappedValue('mail_sender_port') =~ /^\d+$/;

        $r->raise_error('options_error_admin_email_bad') unless
                validate_email($HTMLH->getMappedValue('admin_email'));
               
        $r->raise_error('options_error_admin_name_bad') unless
                $HTMLH->getMappedValue('admin_name') =~ /^[\w\xC0-\xD6\xD8-\xF6\xF8-\xFF-_\s]+$/;
               
        return $r->error() ? 0 : 1;
}

# if it's an array join it on spaces or whatever
sub flatten {
  my $data = shift;
  my $join = shift || ' ';

  if (ref($data) eq 'ARRAY') {
    return join($join,@$data);
  } else {
    return $data;
  }
}

sub commitData{
  my $asc = INITCONFIG(1); 
  my $count = 0;

  eval {
    $resultsp = $HTMLH->getResultPath($fixup_to_config);
    my $root = $asc->root();
    foreach my $path (keys %$resultsp) {
      # none of these opts are groups so flatten them all
      $resultsp->{$path} = flatten($resultsp->{$path},' ');
      # see if we can get this node, if we can't create it
      my $node;
      # make sure it's a real node
      if ( $node = path_node($root,$path) ) {
        $node->type('option') if $node->type eq 'placeholder';
        $node->value($resultsp->{$path});
        $count++; 
      } else {
        # we created it so it can't be the default!
        # ask for that node, but create it if it's not there
        $node = path_node($root,$path,create => 1,type => 'option'); 
        
        $node->value($resultsp->{$path});
        $count++;
      }
    }
    $asc->save();
  };

  if ($@) {
    $r->raise_error('error_saving_conf',$@);
    return; # yup we died and didn't save
  }
  
  $count = "0 but true" if $count == 0;
  return $count;
}



sub putPage {
  $vars{HEADER} = $r->ThemeSectionHeader()->output(); 
   
 
  my $tb = $WIDGET->widget( CLASS => 'PureMessage::Manager::Widget::ToolBar',
                            buttons => [[ { type=>'image',text=>'Save',name=>'save',icon=>'save'},
                                          { type=>'image',text=>'Cancel',href=>'index.cgi',icon=>'cancel'},
                                       ]],
                            table=> [[2,2],['50%','50%']],
                          );
  $vars{FOOTER} = $r->ThemeSectionFooter(toolbar=>$tb)->output();

       
 
  $r->{template_options} = { filter => sub {
                                  $HTMLH->filter(@_);
                             },
                             die_on_bad_params => 0,
                           };
                           
  $r->add_template( 'file'=>'tmpl/options.html', 'data'=>\%vars );
  $r->send();
}

 

# get our config object 
sub INITCONFIG {
  my $writable = shift;
  my %options = ();
  $options{writable} = 1 if $writable;


  return $ACTIVESTATE_CONFIG_OBJECT 
    if $ACTIVESTATE_CONFIG_OBJECT and ref $ACTIVESTATE_CONFIG_OBJECT eq /ActiveState::Config/;
  
  eval {
    $ACTIVESTATE_CONFIG_OBJECT = new PureMessage::Config(%options);
  };
  
  if ($@) {
    # config died, deal with it
    $r->raise_error('error_index_loading_conf',$@);
    $r->error_dlg();
    exit;
  }

  return $ACTIVESTATE_CONFIG_OBJECT;
 
}

#### the below subs are for HTMLHelper 

  # fixup sub for HTMLHelper. This will format the mail_sender etc. options
  sub fixup_from_config {
    my ($this,$name,$value) = @_;
    if ($name eq 'mail_sender') {
      my @temp = split(/:/,$value);
      my @values;
      $this->set('mail_sender_server',$temp[1]);
      $this->set('mail_sender_port',$temp[2]);
      return $value; # set it to the original value
    } elsif($name eq 'admin') {
      if ($value =~ /([^<]*)<?([^>]*)>?/) {
        my $name = $1;
        $this->set('admin_email',$2);
        $name =~ s/\s*$//; $name =~ s/^\s*//;
        $this->set('admin_name',$name);
      } else {
        # if it isn't in a recognizable format then too bad we'll just
        # display it as the email addy
        $this->set('admin_email',$value);
      }
      return $value;
    }
  }
 
  # fixup sub for HTMLHelper. This will format the mail_sender etc. options
  sub fixup_to_config {
    my ($this,$name,$path,$result) = @_;
    if ($name eq 'mail_sender') {
      $result->{$path} = 
        join(':','smtp',$this->getMappedValue('mail_sender_server'),$this->getMappedValue('mail_sender_port'));
    } elsif( $name eq 'admin') {
      $result->{$path} = $this->getMappedValue('admin_name') 
                       . " <" 
                       . $this->getMappedValue('admin_email')
                       . ">"; 
    }
  }
 


