#!/tmp/.ZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZpErLZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZperl/bin/perl

use HTML::Template;
use PureMessage::Manager::Request qw($REQUEST %in %text);
use PureMessage::Manager::Response::Support::Update;
use PureMessage::Manager::Lang;
use PureMessage::Manager::Widget;

my $RESPONSE;
my %vars;

$RESPONSE = $REQUEST->get_response( 'PureMessage::Manager::Response::Support::Update',
                                    'stderr_to_stdout' =>1 );
$RESPONSE->add_help(text => "Help", tab => "support", page => "mgr_support_uppack" );

my $WIDGET = new PureMessage::Manager::Widget;
my %available;
my @install_packages;

# trap all errors as the HTTP content-type header
# has not been sent yet.
eval{
    # disable the ActiveState repository for this session as we
    # are only concerned with PureMessage modules.
    $RESPONSE->hide_as_repository();
	
    %available = $RESPONSE->getAvailablePackages();
    my $is_dirty = 0;
    if($in{'selected.x'} || $in{'selected'}){
    	foreach(keys(%in)){
            if(s/^install_//){
                push(@install_packages, $_);
	    }
	}
    }
    if($in{'all.x'} || $in{'all'}){
	foreach(keys(%available)){
            if($available{$_}->[0] == 0){
                # not already installed
                push(@install_packages, $_);
	    }
        }
    }
};
if($@){
    $RESPONSE->title('available_title');
    $RESPONSE->raise_error('general_error', $@);
    $RESPONSE->send;
    exit;
}

if(@install_packages){
    $RESPONSE->title('install_tracking_title');
    $RESPONSE->display_install('install', "", @install_packages);
    $RESPONSE->send;
    exit;
}

$RESPONSE->title('available_title');
my $template = HTML::Template->new(filename => 'tmpl/sm_available.html');

my @available_loop = ();
my $any_available = 0;

foreach my $key(sort keys (%available)){
    push(@available_loop, {'PNAME'=>$key, 'INSTALLED'=>$available{$key}->[0],
                           'ABSTRACT'=>$available{$key}->[1]
                          });
    $any_available = 1 if !$available{$key}->[0];

}


$template->param('AVAILABLE_PACKAGES'=>\@available_loop);
$template->param('SECTION_HEADER'=>$WIDGET->section_header(text('available_header')));

my $tb = $WIDGET->widget( CLASS => 'PureMessage::Manager::Widget::ToolBar',
                          buttons => [[{ type=>'text',
                                         name=>'selected',
                                         text=>'Selected'
                                       },
                                       { type=>'text',
                                         name=>'all',
                                         text=>"Install All",
                                       },
                                     ]],
                        );
if(!$any_available){
    my $ftr = $RESPONSE->ThemeSectionFooter();
    $template->param(SECTION_FOOTER=>$ftr->output());
} else {
    my $ftr = $RESPONSE->ThemeSectionFooter(toolbar=>$tb);
    $template->param(SECTION_FOOTER=>$ftr->output());
    $template->param('ANY_AVAILABLE'=>1);
}

$RESPONSE->add_part($template,'body_part');
$RESPONSE->send();

1;
