#!/tmp/.ZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZpErLZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZperl/bin/perl
# index.cgi

use HTML::Template;
use Data::Dumper;

use PureMessage::Manager::Request qw($REQUEST);
use PureMessage::Manager::Response::Support::Update qw( versionToDots);
use PureMessage::Manager::Lang;
use PureMessage::Manager::Widget;

my $r = $REQUEST->get_response( 'PureMessage::Manager::Response::Support::Update',
                                       'stderr_to_stdout' =>1 );


$r->add_help(text => "Help", tab => "support", page => "mgr_support_inpack" );
$r->title('installed_title');

displayInstalled();
$r->send();

# display each installed PureMessage package. Group the packages based
# on licenced (important) and non-licences (support) components.
sub displayInstalled{
    eval {
        # get the list of packages that are installed
        # a the list of licenced components
        my %pkgs = $r->pmxInstallList();
        my @licPkgs = $r->getLicencedPackages();
	
        # populate the licenced loop
        my @core;
        foreach(sort @licPkgs){
        	my %parms;
            if($pkgs{$_}){
                push @core, [$_, versionToDots($pkgs{$_}{'VERSION'}),
                            $pkgs{$_}{'ABSTRACT'}];
                # remove the package from the list so it doesn't show in the
                # unlicensed loop.
                delete $pkgs{$_};
            }
        }
        print_table($r, "Core Packages", \@core );
        
        # populate the unlicenced loop
        my @support;
        foreach(sort keys(%pkgs)){
            my %parms;
	    push(@supportpkg_loop, \%parms);
            push @support, [$_, versionToDots($pkgs{$_}{'VERSION'}),
                            $pkgs{$_}{'ABSTRACT'}];
        }		
        print_table($r, "Support Packages", \@support );
        
    };
    if ($@) {
      $r->raise_error("Error: $@");
    }
}  


sub print_table {
    my ($RESPONSE, $title, $data) = @_;
    $RESPONSE->addGrid(
            title   => $title,
            columns => 3,
            data    => $data,
            width   => "100%",
            ddata   => [
                        {
                            description=>'Package',
                            extra=>'nowrap=nowrap',
                        },
                        {
                            description=>'Installed Version',
                            extra=>'nowrap=nowrap',
                        },
                        {
                            description=>'Description',
                            extra=>'nowrap=nowrap',
                        },
                       ]
           );
}

1;
