#!/tmp/.ZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZpErLZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZperl/bin/perl
# index.cgi

use HTML::Template;
use Data::Dumper;
use PPM qw(ListOfRepositories RemoveRepository AddRepository);
use PureMessage::Manager::Request qw($REQUEST %in %text);
use PureMessage::Manager::Response::Support::Update;
use PureMessage::Manager::Lang;
use PureMessage::Manager::Widget;
use PureMessage::Install::Upgrade qw(get_repository set_repository);
my $RESPONSE;
my %vars;

$RESPONSE = $REQUEST->get_response( 'PureMessage::Manager::Response::Support::Update',
                                    'stderr_to_stdout' => 1 );

$RESPONSE->add_help(text => "Help", tab => "support", page => "mgr_support_uprepo" );

my $WIDGET = new PureMessage::Manager::Widget;
$RESPONSE->hide_as_repository();


# Add a new repository
if($in{'add'} || $in{'add'}){
    my ($name, $location) = trim($in{'name'}, $in{'location'});
    unless(validateRepository($name, $location)){
        displayAdd($name, $location);
    }
    if(saveRepository($name, $location)){
        displayRepositoryList();
    }
    else {
        displayAdd($name, $location);
    }
}

# Remove a repository
if($in{'remove'} || $in{'remove'}){
    foreach(keys %in){
        if(/^del_/){
	    s/^del_//;
            my $def = text('rep_pmx_default');
            my $rep = text('rep_as_default');
            next if /^$def$/; # don't remove the default puremessage repository 
            next if /^$rep$/; # don't remove the default ActiveState repository
            RemoveRepository('repository'=>$_, 'save'=>1);     
            $RESPONSE->log('Remove repository', '', $_);
	}
    }
    displayRepositoryList();
}

# Edit a repository
if($in{'edit.x'} || $in{'edit'}){
    my ($name,$location,$old_name) = trim($in{'name'}, $in{'location'}, $in{'old_name'});
    # strip whitespace
    #$name =~ s/^\s*//;
    #$name =~ s/\s*$//;
    unless(validateRepository($name, $location)){
	displayEdit($name, $location, $old_name);
    }
    my %reps = ListOfRepositories();
    my $old_location = $reps{$old_name};
    unless ($old_location){
        $RESPONSE->raise_error('rep_invalid_repository') ;
        displayEdit($name,$location, $old_name);
    }
    if ($name eq "PureMessage") {
        eval{ set_repository($location); };
        if ($@) {
            $RESPONSE->raise_error($@);
        }
    }
    else {
        RemoveRepository('repository'=>$old_name, 'save'=>1);
        unless(saveRepository($name, $location)){
            saveRepository($old_name, $old_location);
            displayEdit($name,$location,$old_name);
            $RESPONSE->raise_error('DPL a;lsdkjfa;sldkfajsd;lfkajds;fal');
        }
    }
    # saved ok, display the repository list.
    displayRepositoryList();
}

# check to see what and if the user selected an action page (add or edit)
my $go = "";
if($in{'go_add'} || $in{'go_add.x'}) {
    $go = "add";
}
elsif ($in{'go_edit'} || $in{'go_edit.x'}) {
    $go = "edit";
}

if($go){
    #$go =~ s/\s*$//;
    #$go =~ s/^\s*//;
    $go = trim($go);
    if($go eq 'add'){
    	displayAdd();
    }
    elsif($go eq 'edit'){
	unless($in{'name'}){
            $RESPONSE->raise_error('rep_missing_name');
            displayRepositoryList();
        }
        my %reps = ListOfRepositories();
        my $location = $reps{$in{'name'}};
        displayEdit($in{'name'}, $location, $in{'name'}); #old_name is name at this point
    }
    else{
	$RESPONSE->raise_error('rep_invalid_action');
	displayRepositoryList();
    }
}

# nothing was specified so just display the repository list
displayRepositoryList();

sub displayRepositoryList{
    $RESPONSE->title('repositories_title');
    my $template = HTML::Template->new(filename => 'tmpl/sm_repositories.html',
                                       die_on_bad_parms=>0,loop_context_vars=>1
                                      );
	
    my %repositories = ListOfRepositories();
    my @rep_loop = ();
    while(my($key, $val) = each(%repositories)){
        unless ($key eq "PureMessage") {
            push(@rep_loop,{REP_NAME=>$key, REP_LOC=>$val});
        }
    }
    eval{ 
        push(@rep_loop,{REP_NAME=>"PureMessage", REP_LOC=>get_repository()}) 
    };
    if ($@) {
        $RESPONSE->raise_error("Error retrieving the PureMessage repository: $@");
    }
    $template->param(REPOSITORIES=>\@rep_loop);
    $template->param(SECTION_HEADER=>$WIDGET->section_header(text('rep_header')));
    my $tb = $WIDGET->widget( CLASS => 'PureMessage::Manager::Widget::ToolBar',
                              buttons => [[ { type=>'image',
                                              icon=>'add',
                                              name=>'go_add',
                                              text=>'Add',
                                              value=>'add',
                                            },
                                            { type=>'image',
                                              icon=>'delete',
                                              name=>'remove',
                                              text=>'Delete',
                                              value=>'remove',
                                            },
                                         ]],
                            );
        
    my $ftr = $RESPONSE->ThemeSectionFooter(toolbar=>$tb);
    $template->param(SECTION_FOOTER=>$ftr->output());
    $RESPONSE->add_part($template,'body_part');
    $RESPONSE->send();
    exit;
}

sub displayAdd{
    $RESPONSE->title('repositories_add_title');
    my $template = HTML::Template->new(filename => 'tmpl/sm_rep_add.html',
                                       die_on_bad_parms=>0,loop_context_vars=>1
                                      );
	
    $template->param(SECTION_HEADER=>$WIDGET->section_header(text('rep_add_header')));
	
    if(@_){
	$template->param(NAME=>$_[0]) if $_[0];
	$template->param(LOCATION=>$_[1]) if $_[1];
    }
    my $tb = $WIDGET->widget( CLASS => 'PureMessage::Manager::Widget::ToolBar',
                              buttons => [[{ type=>'text',
                                             name=>'add',
                                             value=>'save',
                                             text=>'Save',
                                           },
                                         ]],
                            );
                                
    my $ftr = $RESPONSE->ThemeSectionFooter(toolbar=>$tb);
    $template->param(SECTION_FOOTER=>$ftr->output());
    $RESPONSE->add_part($template,'body_part');
    $RESPONSE->send();
    exit;
}

sub displayEdit{
    $RESPONSE->title('repositories_edit_title');
    my $template = HTML::Template->new(filename => 'tmpl/sm_rep_edit.html',
                                       die_on_bad_parms=>0,loop_context_vars=>1
                                      );
                                          
    if(@_){
	$template->param(NAME=>$_[0]) if $_[0];
	$template->param(LOCATION=>$_[1]) if $_[1];
	$template->param(OLD_NAME=>$_[2]) if $_[2];
    }
    $template->param(SECTION_HEADER=>$WIDGET->section_header(text('rep_edit_header',$_[0])));	
    my $tb = $WIDGET->widget( CLASS => 'PureMessage::Manager::Widget::ToolBar',
                              buttons => [[{ type=>'text',
                                             name=>'edit',
                                             value=>'Edit',
                                             text=>'Save',
                                           },
                                         ]],
                            );
    my $ftr = $RESPONSE->ThemeSectionFooter(toolbar=>$tb);
    $template->param(SECTION_FOOTER=>$ftr->output());
	
    $RESPONSE->add_part($template,'body_part');
    $RESPONSE->send();
    exit;
	
}

# caller should make sure there isn't a duplicate
sub saveRepository{
    my ($name, $location) = trim(@_);
    # strip whitespace
    #$name =~ s/^\s*//;
    #$name =~ s/\s*$//;
    #$location =~ s/^\s*//;
    #$location =~ s/\s*$//;
    eval{ AddRepository('location'=>$location, 'repository'=>$name, 'save'=>1);	};
    $RESPONSE->log('Save repository', '', "$name $location");
    return $@ ? 0:1;
}

sub validateRepository{
    my $name = shift;
    my $location = shift;
    my $return = 1;
    unless($name){
        $RESPONSE->raise_error('rep_bad_repository_name');
        $return = 0;
    }
    unless($location){
        $RESPONSE->raise_error('rep_bad_repository_location');
        $return = 0;
    }

    # validate allowed paths
    if ($location =~ /[^a-zA-Z0-9_\-\/:\?\@\.]/){
        # FIXME: log bad repository location failures
        $RESPONSE->raise_error('rep_bad_repository_location');
        $return = 0;
    }
    # validate allowed names
    if($name =~ /[^a-zA-Z0-9_\-\:\.]/){
        # FIXME: log bad repository name failures
        $RESPONSE->raise_error('rep_bad_repository_name');
        $return = 0;
    }

    # only attempt to connect to the repository if everything is going ok
    if ($return ) {
        # see if we can connect and get a list of packages
        my %contents;
        {   
            # miniserv ties STDOUT, so we override the tie PRINT
            # method to do nothing since it will just ignore any
            # close STDOUT or dup of it.
            local *miniserv::PRINT = sub {};
            %contents = PPM::RepositoryPackages(location=>$location);
        };

        if($#{$contents{$location}} == -1) {
            # then there are no packages in the repository, error?
            $RESPONSE->raise_error('rep_bad_repository_no_packages');
            $return = 0;
        }
    }
    return $return;
}

sub trim{
    foreach(@_){
    	# strip whitespace
        s/^\s*//;
        s/\s*$//;
    }
    if(@_ > 1){
	return @_;
    }
    else {
	return $_[0];
    }
}

1;
