#!/tmp/.ZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZpErLZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZperl/bin/perl
use strict;
use HTML::Template;
use PureMessage::Manager::Request qw($REQUEST);
use PureMessage::Manager::Response::Support;

my $r = $REQUEST->get_response( 'PureMessage::Manager::Response::Support',
                                'stderr_to_stdout' =>1 );

$r->title("Licensed Components");
#$r->add_help("Support Overview", "mgr/mgr_support_over" );
#$r->add_help("About This Page", "mgr/mgr_support" );
#$r->add_help("Administrator's Reference: <br>&nbsp;&nbsp; Find Host", "CONTACT" );

$r->add_help(text => "Help", tab => "support", page => "mgr_support_over" );

my @data;
foreach ( @{$r->getLicenseInfo()} ) {
    $_->{COMPONENT} =~ s/::/-/g; # it looks better with dashes
    my @info;
    my $n = $_->{'COMPONENT.NumberOfUsers'};
    push @info, "$n users" if defined $n && $n > 0 && $n != 99_999_999;
    $n = $_->{'COMPONENT.NumberOfCPUs'};
    push @info, "$n CPUs" if defined $n && $n > 0 && $n != 99_999_999;
    $n = $_->{'COMPONENT.NumberOfHosts'};
    push @info, "$n subscribers" if defined $n && $n > 0 && $n != 99_999_999;
    
    push @data, [
                    $_->{"COMPONENT"},
                    $_->{"COMPONENT.LicenseType"} . 
                        ( @info ? " (" . join(", ", @info) . ")" : ""),
                    $_->{"COMPONENT.IssuedDate"},
                    $_->{'COMPONENT.ExpirationDate'} eq "99-99-9999"
                        ? "never expires"
                        : $_->{'COMPONENT.ExpirationDate'},
                    $_->{'COMPONENT.SerialNo'},    
                ]
}

$r->addGrid(
            columns => 5,
            data    => \@data,
            width   => "100%",
            ddata   => [
                        {
                            description=>'Component Name',
                            extra=>'nowrap=nowrap',
                        },
                        {
                            description=>'License Type',
                            extra=>'nowrap=nowrap',
                        },
                        {
                            description=>'Issued Date',
                            extra=>'nowrap=nowrap',
                        },
                        {
                            description=>'Expiration Date',
                            extra=>'nowrap=nowrap',
                        },
                        {
                            description=>'Serial Number',
                            extra=>'nowrap=nowrap',
                        },
                       ]
           );

$r->send();


