package PureMessage::Manager::Response::Services;
use strict;
use PureMessage::Manager::Request;
use PureMessage::Manager::Config qw(%config %web_config);
use PureMessage::Map;
use PureMessage::List;
use PureMessage::Manager::Config qw(%config %web_config);
use PureMessage::Version qw($VERSION $PREFIX);
use File::Spec;
use ActiveState::Config;


our  @ISA = ('PureMessage::Manager::Response');
my $CONFIG_FILE_LOCATION = "$PREFIX/etc/manager/jobtypes.conf";

sub new {
    my $proto = shift;
    my $self = $proto->SUPER::new(@_);
    $self->add_taskmenu({ title => 'Tasks',
                          buttons => [[ {type=>'text',text=>"View Services Status", href=>"/Services/index.cgi"},
                                        {type=>'text',text=>"Edit Global Options", href=>"/Services/options.cgi"}, 
				     ]],
			});
    return $self;
}

sub get_job_action {
    my $self = shift;
    my ($command_line) = @_;

    # return 'class' actions as-is
    return $command_line if $command_line =~ /::/;
    
    my ($cmd,@junk) = split(/\s/,$command_line);
    my ($junk,$junk2,$name) = File::Spec->splitpath($cmd);
    return $name;
}

sub _init_as_object {
      my $self = shift;
      my $ACTIVESTATE_CONFIG_OBJECT;
      eval {
        $ACTIVESTATE_CONFIG_OBJECT = new ActiveState::Config();
        $ACTIVESTATE_CONFIG_OBJECT->parse_file($CONFIG_FILE_LOCATION);
      };
      if (!$@) {
        # config died, deal with it
        $self->{JOBS} = $ACTIVESTATE_CONFIG_OBJECT->as_hash();
      } else {
        $self->raise_error('Unable to load cron names. Using Raw Names Instead'); 
      }
      return $ACTIVESTATE_CONFIG_OBJECT;
}




1;
