package PureMessage::Manager::Response::Support;
use strict;
use PureMessage::Manager::Request;
use PureMessage::Manager::Config qw(%config %web_config);

our  @ISA = ('PureMessage::Manager::Response');

sub new {
    my $proto = shift;
    my $self = $proto->SUPER::new(@_);

    $self->add_taskmenu({ title => 'Update Software',
                          buttons => [[
                                        { type=>'text', text=>'View Licensed Components', href=>'/Support/index.cgi'},
                                        { type=>'text', text=>'Check for Updates', href=>'/Support/Update/sm_upgrades.cgi'},
                                        { type=>'text', text=>'View Installed Packages', href=>'/Support/Update/sm_installed.cgi'},
                                        { type=>'text', text=>'Package Repositories', href=>'/Support/Update/sm_repositories.cgi'},
                                     ]],
                        });
    
    $self->add_taskmenu({ title => 'Other Tasks',
                          buttons => [[
										{type=>'text', text=>"Manage Snapshots", href=>"/Support/Snapshots/"},
                                        {type=>'text', text=>"Product Home Page", href=>"http://www.sophos.com/products/pm", target=>"_new"},
                                        {type=>'text', text=>"Mailing List Archive", href=>"http://pminfo.sophos.com/pmarchive", target=>"_new"},
                                        {type=>'text', text=>"PureMessage User Guide", href=>"/help.cgi", target=>"docs"},
                                     ]],
                        });
    
    return $self;
}


sub getLicenseInfo {
  my $info;
  my @lic;

  open FV,"$PureMessage::Config::lic_file" or return;
  while( <FV> ) {
    chomp;
    my @parts = split('\|',$_);
    shift(@parts); # discard the sensitive bit
    my $href;
    $href->{'COMPONENT'} = shift(@parts);

    my @components;
    
    foreach my $part (@parts) {
      my @kv = split('#',$part);
      # flatten the values so they are easy to use from HTML::Template
      $href->{"COMPONENT.$kv[0]"} = $kv[1];
    }

    push(@lic,$href);
  }
  close FV;

  return \@lic;
}

sub ppm_log_file {
    "$web_config{root}/Support/record.ppm.log";
}

sub write_ppm_log {
        my $this = shift;
        my $text = shift;
        my $clear = shift;
	my $log_file = $this->ppm_log_file;
        my $mode = $clear ? ">" : ">>"; 
        open FV,"$mode$log_file" or return;
        print FV $text;
        close FV;
}

sub get_ppm_log {
        my $this = shift;
	my @data;
#        my $log_dir = "$web_config{'root'}/Support/Update";
	my $log_file = $this->ppm_log_file;

	open FH, "<$log_file" or die "Failed to open the ppm log. $!";
	@data = <FH>;
	close FH;
	return join('', @data);
}




1;
